%{!?_texmf: %define _texmf %(eval "[ -x /usr/bin/kpsewhich ] && echo `kpsewhich -expand-var '$TEXMFMAIN'` || echo %{_datadir}/texmf")}

Summary:       Translates TeX and LaTeX into HTML or XML+MathML
Name:          tetex-tex4ht
Version:       1.0.2006_10_28_1705
Release:       1%{?dist}
License:       LaTeX Project Public License
Group:         Applications/Publishing
URL:           http://www.cse.ohio-state.edu/~gurari/TeX4ht/
Source0:       http://www.cse.ohio-state.edu/~gurari/TeX4ht/fix/tex4ht-%{version}.tar.gz
# Source1 is only used for documentation
# renamed to tex4ht-all-YYYYMMDD.zip - based on last timestamp in directory
Source1: tex4ht-all-20050228.zip
# unversioned upstream source, downloaded with wget -N
#Source1 http://www.cse.ohio-state.edu/~gurari/TeX4ht/tex4ht-all.zip
Source2:       tex4ht-lppl.txt
# unversioned upstream litteral source, downloaded with wget -N
#Source3:       http://www.cse.ohio-state.edu/~gurari/TeX4ht/fix/tex4ht-lit.zip
Source3:       tex4ht-lit-20061028.zip
Source4:       http://www.cse.ohio-state.edu/~gurari/tpf/ProTex.sty
Source5:       http://www.cse.ohio-state.edu/~gurari/tpf/AlProTex.sty
Source6:       http://www.cse.ohio-state.edu/~gurari/tpf/DraTex.sty
Source7:       http://www.cse.ohio-state.edu/~gurari/tpf/AlDraTex.sty
#Patch0:        tex4ht-1.0.2006_10_24_0142-paths.patch
# debian
Patch1:         http://ftp.debian.org/debian/pool/main/t/tex4ht/tex4ht_20060913-1.diff.gz
# patch similar from debian/lit/texmf.cnf.patch, modified to fit fedora
Patch2:        texmf.cnf.patch
# update debian rebuild script
Patch3:        tetex-tex4ht-1.0-prev.patch
# if building from litteral sources, install xtpipes files in dest
Patch4:        tetex-tex4ht-1.0.2006_10_24_0142-nohome.patch
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  /usr/bin/kpsewhich
BuildRequires:  tetex-fonts
# for uudecode to generate the debian tutorial images
BuildRequires:  sharutils
# pnmcrop and pnmtopng are in netpbm-progs. 
Requires:       netpbm-progs
# ImageMagick, pstoedit depends on ghostscript and gs is in ghostscript
Requires:       ImageMagick pstoedit
# dvips is in tetex-dvips. tetex-latex depends on tetex-dvips.
# dvipng is in tetex. tetex-latex depends on tetex.
Requires:       tetex-latex
Requires(post):   /usr/bin/texhash
Requires(postun): /usr/bin/texhash
Obsoletes:      tex4ht < %{version}-%{release}
Provides:       tex4ht = %{version}-%{release}

# description taken from ctan and modified
%description 
A converter from TeX and LaTeX to hypertext (HTML, XML, etc.), providing a
configurable (La)TeX-based authoring system for hypertext. When converting
to XML, you can use MathML instead of images for equation representation.

This package can also be used to translated to XML that OpenOffice.org can
understand, which then gives the user a path by which to convert a document
to rtf for import into Microsoft Word.

%prep
%setup -q -n tex4ht-%{version}
%patch1 -p1

# apply debian path which avoids using xtpipes since we cannot compile it
patch -p1 < debian/patches/fix_mk4ht.diff

chmod a-x src/*.c
cp %{SOURCE2} lppl.txt
mkdir doc
cp %{SOURCE1} doc
pushd doc 
unzip tex4ht-all-*.zip
rm *.zip
popd
mkdir lit
cp %{SOURCE3} lit
pushd lit
unzip tex4ht-lit-*.zip
rm *.zip
chmod 0644 *.tex
popd
cp -p %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7} lit/

# avoid duplicating the debian patches while still allowing to rebuild
# from literate sources
patch -p1 < debian/lit/patches/fix_tex4ht_dir.diff
patch -p1 < debian/lit/patches/fix_tex4ht_fonts_4hf.diff
%patch4 -p1 -b .nohome

patch -p1 < debian/patches/add_manpage.diff

cp %{PATCH2} debian/lit/

%patch3 -p1 -b .prev

chmod a+x debian/lit/rebuild.sh*

(cd debian/images; for i in *.uue; do uudecode $i; done; mv *.png ../html)

find  texmf -type f -exec chmod a-x \{\} \;

%build
pushd src
CFLAGS="$RPM_OPT_FLAGS -DHAVE_STRING_H -DHAVE_DIRENT_H -DHAVE_UNISTD_H \
 -DHAVE_SYS_DIR_H -DKPATHSEA -DENVFILE=\"%{_texmf}/tex4ht/base/unix/tex4ht.env\""
LDFLAGS=-lkpathsea
gcc -o tex4ht $CFLAGS tex4ht.c $LDFLAGS
gcc -o t4ht $CFLAGS t4ht.c $LDFLAGS
popd

# files in bin/ht/unix have a shebang but use xtpipes

# add shebangs to the scripts that lacks one
for file in bin/unix/*; do
    if grep '^#! */' $file > /dev/null 2>&1; then continue; fi 
    echo "#! /bin/sh" | cat - $file > $file.new
    mv $file.new $file
done

%install
rm -rf $RPM_BUILD_ROOT

install -d -m755 $RPM_BUILD_ROOT%{_bindir}
install -m755 src/tex4ht $RPM_BUILD_ROOT%{_bindir}
install -m755 src/t4ht $RPM_BUILD_ROOT%{_bindir}
#install -m755 bin/ht/unix/* $RPM_BUILD_ROOT%{_bindir}
install -m755 bin/unix/* $RPM_BUILD_ROOT%{_bindir}

pushd texmf
install -d -m755 $RPM_BUILD_ROOT%{_texmf}/tex4ht/base/unix
cp tex4ht/base/unix/tex4ht.env $RPM_BUILD_ROOT%{_texmf}/tex4ht/base/unix

cp -pr tex4ht/ht-fonts $RPM_BUILD_ROOT%{_texmf}/tex4ht

install -d -m755 $RPM_BUILD_ROOT%{_texmf}/tex/generic
cp -pr tex/generic/tex4ht $RPM_BUILD_ROOT%{_texmf}/tex/generic
popd

cp -pr debian/html tutorial

sed 's/Debian packaged/Debian and Fedora packaged/' debian/README.kpathsea \
   > README.kpathsea 

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
sed -e 's;@SCRIPTSDIR@;%{_bindir};' \
 -e 's;@TEX4HTDIR@;%{_texmf}/tex4ht/base/unix;' \
 -e 's;@TEXMFCNF@;%{_texmf}/web2c/texmf.cnf;' \
 -e 's;@HTFDIR@;%{_texmf}/tex4ht/ht-fonts;' \
 -e 's;@TEXDIR@;%{_texmf}/tex/generic/tex4ht;g' \
 src/tex4ht.man > $RPM_BUILD_ROOT%{_mandir}/man1/tex4ht.1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{_texmf}/tex4ht/
%{_texmf}/tex/generic/tex4ht/
%{_bindir}/*
%{_mandir}/man1/tex4ht.1*
%doc lppl.txt doc tutorial README.kpathsea 

%post
texhash > /dev/null 2>&1 || :

%postun
texhash > /dev/null 2>&1 || :

%changelog
* Fri Nov  3 2006 Patrice Dumas <pertusus@free.fr> 1.0.2006_10_28_1705-1
- update
- use debian patchset
- remove the patch modifying paths in tex4ht.env, it is unneeded with 
  kpathsee

* Mon Aug 28 2006 Patrice Dumas <pertusus@free.fr> 1.0.2006_08_26_2341-2
- update

* Tue Jun 20 2006 Patrice Dumas <pertusus@free.fr> - 1.0.2006_06_19_1646-1
- update

* Fri Mar 31 2006 Patrice Dumas <pertusus@free.fr> - 1.0.2006_03_27_1822-1
- update

* Fri Feb 17 2006 Patrice Dumas <pertusus@free.fr> - 1.0.2006_02_15_1234-1
- update

* Thu Dec 22 2005 Patrice Dumas <pertusus@free.fr> - 1.0.2005_12_21_0412-1
- update

* Mon Nov 14 2005 Patrice Dumas <pertusus@free.fr> - 1.0.2005_11_06_1516-3
- add Requires for ImageMagick

* Mon Nov 14 2005 Patrice Dumas <pertusus@free.fr> - 1.0.2005_11_06_1516-2
- keep timestamps, use tex4ht-all-YYYYMMDD.zip (Michael A. Peters)

* Sun Nov 13 2005 Patrice Dumas <pertusus@free.fr> - 1.0.2005_11_06_1516-1
- updated version

* Sat Nov  5 2005 Patrice Dumas <pertusus@free.fr> - 1.0.2005_10_31_0336-1
- updated version
- added website documentation
- added licence

* Wed Sep 21 2005 Michael A. Peters <mpeters@mac.com> - 1.0-0.2005_09_13_0129.1
- updated version
- got rid of patch that makes Makefile, specify build option in build
- use -DKPATHSEA
- added obsoletes tex4ht due to renaming

* Mon Sep 19 2005 Michael A. Peters <mpeters@mac.com> - 1.0-0.2005_02_16_2023.1
- cleaned up spec file to be closer to Fedora Extras standards
- renamed package from tex4ht to tetex-tex4ht

* Wed Feb 9 2005 Erik Sjolund <erik.sjolund@sbc.su.se>
- New upstream release
- merged the two patches into one
* Wed Feb  9 2005 Edward Grace <graceej@ptpc3lin.op.ph.ic.ac.uk> - 1.0.2004_12_16_1626-2
- Added a requirement for tetex
- On FC2 the font directory was not being correctly found, added a trivial 
  patch which corrects this. It also works with Fedora Core 3
- Added the URL specifier to point to Erik Sjölund's page where I found the sources.
* Mon Dec 20 2004 Erik Sjolund <erik.sjolund@home.se>
- New upstream release
- Switched to Fedora Core 3
* Wed Oct 15 2004 Erik Sjolund <erik.sjolund@home.se>
- New upstream release
- Thanks Neil D. Becker for the changes to the spec file
  in this release!
- The files section totally restructured. Instead of specifying
  single files explicitly, the directories containg all the files
  are specified instead. 
* Wed Sep 22 2004 Erik Sjolund <erik.sjolund@home.se>
- New upstream release
- I had to remove 
  /usr/bin/htcontext.unix
  /usr/bin/xhcontext.unix
  from the files section as they were no longer shipped.
* Wed Jul 14 2004 Erik Sjolund <erik.sjolund@home.se>
- Adjusted the /usr/src/redhat/SOURCES/tex4ht-redhat.patch so that 
  texmf/tex4ht/base/unix/tex4ht.env now has the line "l~/.tex4ht.fls"
* Tue Jul 13 2004 Erik Sjolund <erik.sjolund@home.se>
- I downloaded new sources from
  http://www.cse.ohio-state.edu/~gurari/TeX4ht/bugfixes.html.
  # Google gives the first hit on tex4ht as
  # http://www.cse.ohio-state.edu/~gurari/TeX4ht/mn.html
  # That page seems not be the primary source of the latest news about tex4ht.
  # Look instead at http://www.cse.ohio-state.edu/~gurari/TeX4ht/bugfixes.html
  # to get the latest sources.
- I adjusted /usr/src/redhat/SOURCES/tex4ht-redhat.patch to conform to the new
  sources
- There were some new installed files, so I included them in the files section:
  /usr/bin/dbmtexexec
  /usr/bin/dbtexexec
  /usr/bin/htcontext
  /usr/bin/htcontext.unix
  /usr/bin/httexexec
  /usr/bin/mk4ht 
  /usr/bin/mztexexec
  /usr/bin/ootexexec
  /usr/bin/teimtexexec
  /usr/bin/teitexexec
  /usr/bin/xhcontext
  /usr/bin/xhcontext.unix
  /usr/bin/xhmtexexec
  /usr/bin/xhtexexec

- Packager: John Langford 

